library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;



entity count is
    Port ( GCLK : in  STD_LOGIC;
           DIR : in  STD_LOGIC;
	   RESET : in STD_LOGIC;
           OUTPUT : out  STD_LOGIC_VECTOR (2 downto 0));
end count;

architecture Behavioral of count is

signal counter : STD_LOGIC_VECTOR (2 downto 0) := (others => '0');

begin

	process (GCLK)
	begin
		if rising_edge(GCLK) then
			counter <= (others => '1');
		else
			if RESET = '1' then
				if DIR = '1' then
					counter <= counter + 1;
				else
					counter <= counter - 1;
				end if;
			end if;
		end if;
	end process;

	OUTPUT <= not counter;

end Behavioral;
